﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Soubory
{
    public partial class Window : Form
    {
        public Window()
        {
            InitializeComponent();
        }

        private void show(TreeNodeCollection target,
                          DirectoryInfo source,
                          int level)
        {
            TreeNode node = new TreeNode();
            node.Text = source.Name;
            node.ToolTipText = source.FullName;
            node.Tag = source;

            try
            {
                if (level > 1)
                    foreach (DirectoryInfo d in source.GetDirectories())
                        show(node.Nodes, d, level - 1);
            }
            catch (Exception ex)
            {
            }


            target.Add(node);
        }

        private void treeView_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            TreeNode node = e.Node;
            DirectoryInfo dir = node.Tag as DirectoryInfo;

            foreach (TreeNode n in node.Nodes)
            {
                if (n.Nodes.Count == 0)
                {
                    DirectoryInfo d = n.Tag as DirectoryInfo;
                    try
                    {
                        foreach (DirectoryInfo s in d.GetDirectories())
                            show(n.Nodes, s, 1);
                    }
                    catch (Exception ex)
                    { 
                    }

                }
            }
        }

        private void testButton_Click(object sender, EventArgs e)
        {
            DriveInfo [] disks = DriveInfo.GetDrives();
            foreach (DriveInfo disk in disks)
               show (treeView.Nodes, disk.RootDirectory, 2);

            // DirectoryInfo dir = new DirectoryInfo("C:\\");
            // show(treeView.Nodes, dir, 2);

            /*
            DirectoryInfo[] subdirs =  dir.GetDirectories();

            TreeNode above = new TreeNode();
            above.Text = dir.Name;
            above.ToolTipText = dir.FullName;
            above.Tag = dir;

            foreach (DirectoryInfo d in subdirs)
            {
                TreeNode node = new TreeNode();
                node.Text = d.Name;
                node.ToolTipText = d.FullName;
                node.Tag = d;
                above.Nodes.Add(node);
            }

            treeView.Nodes.Add(above);
            */

            /*
            FileInfo[] files = dir.GetFiles();
            foreach (FileInfo f in files)
            {
                ListViewItem item = new ListViewItem ();
                item.Text = f.Name;
                item.ToolTipText = f.FullName;
                item.Tag = f;
                item.SubItems.Add("" + f.Length);
                listView.Items.Add(item);
            }
            */
        }

        private void treeView_AfterSelect(object sender, TreeViewEventArgs e)
        {
            TreeNode node = e.Node;
            DirectoryInfo dir = node.Tag as DirectoryInfo;
            listView.Items.Clear();
            try
            {
                FileInfo[] files = dir.GetFiles();
                foreach (FileInfo f in files)
                {
                    ListViewItem item = new ListViewItem();
                    item.Text = f.Name;
                    item.ToolTipText = f.FullName;
                    item.Tag = f;
                    item.SubItems.Add("" + f.Length);
                    listView.Items.Add(item);
                }
            }
            catch (Exception ex)
            {
            }

        }

        private void listView_ItemActivate(object sender, EventArgs e)
        {
            if (listView.SelectedItems.Count > 0)
            {
                ListViewItem item = listView.SelectedItems[0];
            }
        }

    }
}
